unit untBead;

interface

uses
  Classes;

type
  // the TBead class stores the x and y of the bead, and the color index
  // descended from TPersistent to support streaming to disk, and each 
  // saves and loads its own data from the stream.
  TBead = class(TPersistent)
  public
    X: integer;
    Y: integer;
    C: integer;
    procedure SaveToStream(Stream: TStream);
    procedure LoadFromStream(Stream: TStream);
  end;

implementation

// call the method on the stream to read its data
procedure TBead.LoadFromStream(Stream: TStream);
begin
  Stream.ReadBuffer(X, SizeOf(integer));
  Stream.ReadBuffer(Y, SizeOf(integer));
  Stream.ReadBuffer(C, SizeOf(integer));
end;

// call the method on the stream to save its data
procedure TBead.SaveToStream(Stream: TStream);
begin
  Stream.WriteBuffer(X, SizeOf(integer));
  Stream.WriteBuffer(Y, SizeOf(integer));
  Stream.WriteBuffer(C, SizeOf(integer));
end;

end.
